package org.bench4q.recorder;

import java.io.IOException;
import java.nio.charset.Charset;

import org.apache.commons.httpclient.HostConfiguration;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.URI;
import org.apache.commons.httpclient.URIException;
import org.apache.commons.httpclient.methods.GetMethod;
import org.bench4q.recorder.httpcapture.Bench4qTestScriptAdapter;
import org.bench4q.recorder.httpcapture.IScriptAdapter;
import org.bench4q.recorder.httpcapture.ProxyServer;
import org.bench4q.recorder.httpcapture.RequestHandler;
import org.bench4q.recorder.httpcapture.generator.Bench4qCodeGenerator;
import org.bench4q.recorder.httpcapture.generator.ChildrenUrl;
import org.bench4q.share.models.agent.RunScenarioModel;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.scriptrecord.UsePluginModel;
import org.junit.Test;

public class Test_RequestHandler {
	private static final int PORT = 8910;

	@Test
	public void test() {
		try {
			ProxyServer proxyServer = new ProxyServer(PORT);
			Bench4qCodeGenerator observer = new Bench4qCodeGenerator(
					new Bench4qTestScriptAdapter(new RunScenarioModel()));
			proxyServer.addObserver(observer);
			RequestHandler requestHandler = new RequestHandler(proxyServer,
					proxyServer.getServerSocket().accept());
			requestHandler.run();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void test2() {
		new SendRequest().run();
	}

	private static class SendRequest implements Runnable {
		private HttpClient httpClient = new HttpClient();

		@SuppressWarnings("deprecation")
		public void run() {
			HostConfiguration hostConfiguration = new HostConfiguration();
			hostConfiguration.setProxy("127.0.0.1", PORT);
			httpClient.setHostConfiguration(hostConfiguration);
			GetMethod get = new GetMethod();
			try {
				get.setURI(new URI("http://www.baidu.com"));
				int statusCode = this.httpClient.executeMethod(get);
				System.out.println(statusCode);
				System.out.println(new String(get.getResponseBody(), Charset
						.forName("utf-8")));
			} catch (URIException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (HttpException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

	}
}
